﻿
Imports System.Data.OleDb

Public Class FTestDB

    Dim MiConexion As New OleDbConnection
    Dim MiAdapter As OleDbDataAdapter
    Dim MiCommandBuilder As New OleDbCommandBuilder
    Dim UnComando As New OleDbCommand
    Dim MiDatos As New DataSet
    Dim NombreTablaEnDB As String

    Dim BS As New BindingSource

    ' ******** BindingNavigator *** Si necesario ...
    Dim BDN As New BindingNavigator(True)

    Private Sub ParametreConnexion()
        'Dim NombreDBCompleto As String = "D:\Tmp\TestAccesDBCommandBuilder\TestAccesDBCommandBuilder\MonStock2003.mdb"   ' MiExistencia
        'MiConexion.ConnectionString = "Provider=Microsoft.JET.OLEDB.4.0;Data Source=" & NombreDBCompleto & ";"  ' Exécuter en x86

        Dim NombreDBCompleto As String = "D:\Tmp\TestAccesDBCommandBuilder\MonStock2013.accdb"   ' MiExistencia
        MiConexion.ConnectionString = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" & NombreDBCompleto & ";"  ' Ejecutar en x64
    End Sub

    Private Sub FTestDB_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If MiDatos.HasChanges Then
            If MessageBox.Show("Resgistrar cambios (Enregistrer les modifications) ?", "Attention", MessageBoxButtons.YesNo) = DialogResult.Yes Then
                BRegistrar_Click(Me, Nothing)
            End If
        End If
    End Sub

    Private Sub BRegistrar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BRegistrar.Click

        If Not MiDatos.HasChanges Then Exit Sub

        ParametreConnexion()  ' Leer la cadena de conexion

        Dim Consulta As String

        Consulta = "SELECT * FROM " & NombreTablaEnDB
        UnComando.CommandText = Consulta
        UnComando.Connection = MiConexion

        MiAdapter = New OleDbDataAdapter(Consulta, MiConexion)
        MiAdapter.SelectCommand = UnComando

        MiCommandBuilder.DataAdapter = MiAdapter
        MiAdapter.Update(MiDatos.Tables(NombreTablaEnDB))

        MiAdapter.Dispose()

        ' !!! Les GetUpdate, GetDelete et GetInsert ne fonctionnent pas avec XLS car pas de clé primaire et ils ne fonctionnent pas avec des jointures !
        ' !!! Los GetUpdate, GetDelete y GetInsert no funcionan con XLS porque no existe PrimaryKey y no funcionan con JOIN !

    End Sub

    Private Sub CargarLaTabla()

        ParametreConnexion()

        NombreTablaEnDB = "TProduit"   ' este es LaTablaQueMeGusta

        Dim UnaTabla As New DataTable
        Dim Consulta As String

        Consulta = "SELECT * FROM " & NombreTablaEnDB

        MiAdapter = New OleDbDataAdapter(Consulta, MiConexion)

        MiAdapter.Fill(UnaTabla)

        UnaTabla.TableName = NombreTablaEnDB

        MiDatos.Tables.Add(UnaTabla)
        BS.DataSource = UnaTabla

        ' ******** BindingNavigator ***
        ' No es necesario el BindingNavigator
        ' En este ejemplo, utilizo mis botones personale y el BindingNavigator hace duplico, pero da los botones agregar y borrar
        BDN.BindingSource = BS
        Me.Controls.Add(BDN)
        ' ******** Fin Test BindingNavigator ***

        'DGVTest es un DataGridView

        DGVTest.DataSource = BS  ' UnaTabla  ' Para ejemplo, todos campos

        'CBTest es un ComboBox

        CBTest.DataSource = BS  ' UnaTabla
        CBTest.DisplayMember = "Article" ' este es el NombredelCampoQueMeGustaAqui, articulo

        'LBTest es un ListBox

        LBTest.DataSource = BS  ' UnaTabla
        LBTest.DisplayMember = "Article" ' este es ElNombredelCampoQueMeGustaAqui, articulo

        'TBTest es un TextBox

        '    TBTest.DataBindings.Add("Text", UnaTabla, "Stock") ' este es ElNombredelCampoQueMeGustaAqui, este es la cuantidad de articulos
        TBTest.DataBindings.Add("Text", BS, "Stock") ' este es ElNombredelCampoQueMeGustaAqui, este es la cuantidad de articulos

        MiAdapter.Dispose()
        MiConexion.Close()
        MiConexion.Dispose()

    End Sub

    ' El bloque de gestión de lectura. Un solo procedimiente evento responde a 4 fuentes de Click : BPrimero, BAnterior, BSiguiente y BUltimo
    Private Sub LecturaCircular_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BUltimo.Click, BAnterior.Click, BSiguiente.Click, BPrimero.Click
        ' No es necesario intentar un movimiento si el DataSet no contiene ninguna tabla.
        If MiDatos.Tables.Count > 0 Then
            With BS
                ' Modificacion de la propiedad Position segun el boton seleccionado.
                Select Case sender.Name
                    Case "BPrimero"
                        .Position = 0
                    Case "BAnterior"
                        If .Position = 0 Then
                            .Position = .Count - 1              ' Lectura circular (como un reloj pero al revés)
                        Else
                            .Position -= 1
                        End If
                    Case "BSiguiente"
                        If .Position = .Count - 1 Then
                            .Position = 0                       ' Lectura circular (como un reloj)
                        Else
                            .Position += 1
                        End If
                    Case "BUltimo"
                        .Position = .Count - 1
                End Select
            End With
        End If
    End Sub

    Private Sub BCargar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BCargar.Click
        MiDatos.Reset()
        DGVTest.DataSource = Nothing
        CBTest.DataSource = Nothing
        LBTest.DataSource = Nothing
        TBTest.DataBindings.Clear()
        CargarLaTabla()
    End Sub

End Class


